/*
 * Copyright (c) 2013 Nathaniel Jones
 * Massachusetts Institute of Technology
 */

#include <curand_kernel.h>
#include "commonStructs.h"


#ifndef M_PIf
#define M_PIf       3.14159265358979323846f
#endif

#ifndef FTINY
#define  FTINY		(1e-6f)
#endif

//#define  FHUGE		(1e10f)

#ifndef AVGREFL
#define  AVGREFL	0.5f	/* assumed average reflectance */
#endif

//#define RAYCOUNT

typedef curandState_t rand_state;

#ifdef __CUDACC__
struct PerRayData_radiance
{
	float3 result;
	float weight;
	float distance;
	int depth;
	int ambient_depth;
	rand_state* state;
#ifdef RAYCOUNT
	int ray_count;
#endif
};

struct PerRayData_shadow
{
	float3 result;
};

struct PerRayData_ambient
{
	float3 result;
	float3 surface_normal;
	float weight;
	float wsum;
	int ambient_depth;
	rand_state* state;
};

struct PerRayData_ambient_record
{
	AmbientRecord result;
	AmbientRecord* parent;
	rand_state* state;
};

/* The following is from the random.h associated with OptiX. */

//// Generate random unsigned int in [0, 2^24)
//static __device__ __inline__ unsigned int lcg(unsigned int &prev)
//{
//	const unsigned int LCG_A = 1664525u;
//	const unsigned int LCG_C = 1013904223u;
//	prev = (LCG_A * prev + LCG_C);
//	return prev & 0x00FFFFFF;
//}
//
//// Generate random float in [0, 1)
//static __device__ __inline__ float rnd(unsigned int &prev)
//{
//	return ((float) lcg(prev) / (float) 0x01000000);
//}
#endif
